#include <inklevel.h>
#include <glib.h>
#include <config.h>
#include <inkblot.h>
#include <gconf/gconf-client.h>

gint inkblot_scan_devices ( void ) {

	GConfClient	*client = gconf_client_get_default ();
	GtkWidget       *conf_dialog;
        gchar           *message, *bus_d, *port_d;
        gint            buttons;
        gint            type;
        gint            response;
	gint 		bus = 0, port = 0, result, num_printers = 0;
	struct 		ink_level device;
	InkblotPrinter 	*pref_device;

	printers = NULL;
	for (bus=0; bus <3; bus++) {
		for (port=0; port<17; port++) {
			result = get_ink_level (bus, port, &device);
			if (result == 0) {
				InkblotPrinter *dev = g_new0(InkblotPrinter,1);
				dev->model = g_strdup(device.model);
				dev->bus = bus;
				dev->port = port;
				dev->type = device.type;
				printers = g_list_prepend (printers, dev);
				num_printers++;
			}
		}
	}
	if (num_printers < 1) inkblot_error_dialog(INKBLOT_ERROR_NO_PRINTER);

	/* FIXME: temp restrict to first printer. need a UI for selection */
	num_printers = 1;

	if (num_printers > 1) {
				g_print("Choose Printer Not Implemented");
	} else {
		pref_device = g_list_first(printers)->data;
	}

	gconf_client_set_int (client, INKBLOT_BUS_KEY,pref_device->bus,NULL);
	gconf_client_set_int (client, INKBLOT_CONFIG_KEY,1,NULL);

	if (pref_device->bus == 1) {
		bus_d = g_strdup ("parallel port");
	} else {
		bus_d = g_strdup ("USB");
	}
	port_d = g_strdup_printf ("lp%d",pref_device->port);
	message = g_strdup_printf ("Found <i>%s</i> %s printer on %s\n\n"
				   "Inkblot will report the ink level on "
				   "this device.",
				   pref_device->model,bus_d,port_d);
	g_free(port_d);
	g_free(bus_d);
	g_free(pref_device);
	conf_dialog = gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_INFO,
                                         GTK_BUTTONS_OK,
					 "<b><big>%s</big></b>\n\n%s",
                                         "Printer Detection Complete", message);
        gtk_label_set_use_markup 
                       (GTK_LABEL(GTK_MESSAGE_DIALOG(conf_dialog)->label),TRUE);
	gtk_window_set_title (GTK_WINDOW(conf_dialog),"Inkblot Setup");
        response = gtk_dialog_run (GTK_DIALOG(conf_dialog));
        g_free(message);
	gtk_widget_destroy(conf_dialog);
}
